#include <stddef.h>
#include <stdint.h>
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "console.h"
#include "io.h"

void con_set_baudrate(uint32_t b)
{
    uint32_t bauddiv = (CON_BAUD_BASE + (b >> 1))/b;
    CON_BAUDDIV = bauddiv ? bauddiv - 1 : 0;
}

void con_putc(char c)
{
    CONSOLE = c;
    udelay(10);
}

void con_puts(const char *str)
{
    while (*str)
	con_putc(*str++);
}

void con_vprintf(const char *fmt, va_list ap)
{
    char buf[128];		/* Maximum text size */
    unsigned int len;
    const char *p;

    vsnprintf(buf, sizeof buf, fmt, ap);
    con_puts(buf);
}

void con_printf(const char *fmt, ...)
{
    va_list ap;
    va_start(ap, fmt);
    con_vprintf(fmt, ap);
    va_end(ap);
}
